local vRP = Proxy.getInterface('vRP')

local Keys = {
    ["ESC"] = 322,
    ["F1"] = 288,
    ["F2"] = 289,
    ["F3"] = 170,
    ["F5"] = 166,
    ["F6"] = 167,
    ["F7"] = 168,
    ["F8"] = 169,
    ["F9"] = 56,
    ["F10"] = 57,
    ["~"] = 243,
    ["-"] = 84,
    ["="] = 83,
    ["BACKSPACE"] = 177,
    ["TAB"] = 37,
    ["Q"] = 44,
    ["W"] = 32,
    ["E"] = 38,
    ["R"] = 45,
    ["T"] = 245,
    ["Y"] = 246,
    ["U"] = 303,
    ["P"] = 199,
    ["["] = 39,
    ["]"] = 40,
    ["ENTER"] = 18,
    ["CAPS"] = 137,
    ["A"] = 34,
    ["S"] = 8,
    ["D"] = 9,
    ["F"] = 23,
    ["G"] = 47,
    ["H"] = 74,
    ["K"] = 311,
    ["L"] = 182,
    ["LEFTSHIFT"] = 21,
    ["Z"] = 20,
    ["X"] = 73,
    ["C"] = 26,
    ["V"] = 0,
    ["B"] = 29,
    ["N"] = 249,
    ["M"] = 244,
    [","] = 82,
    ["."] = 81,
    ["LEFTCTRL"] = 36,
    ["LEFTALT"] = 19,
    ["SPACE"] = 22,
    ["RIGHTCTRL"] = 70,
    ["HOME"] = 213,
    ["PAGEUP"] = 10,
    ["PAGEDOWN"] = 11,
    ["DELETE"] = 178,
    ["LEFT"] = 174,
    ["RIGHT"] = 175,
    ["TOP"] = 27,
    ["DOWN"] = 173,
    ["NENTER"] = 201,
    ["N4"] = 108,
    ["N5"] = 60,
    ["N6"] = 107,
    ["N+"] = 96,
    ["N-"] = 97,
    ["N7"] = 117,
    ["N8"] = 61,
    ["N9"] = 118
}

local labels = {}
local craftingQueue = {}
local xp = 0
local job = ""
local grade = 0

function isNearWorkbench()
    local ped = PlayerPedId()
    local coords = GetEntityCoords(ped)
    local near = false

    for _, v in ipairs(Config.Workbenches) do
        local dst = #(coords - v.coords)
        if dst < v.radius then
            near = true
        end
    end

    if near then
        return true
    else
        return false
    end
end

RegisterNetEvent("core_jobs:getOre")
AddEventHandler("core_jobs:getOre",function(value)
        xp = value
end)

RegisterNetEvent("core_jobs:getNames")
AddEventHandler("core_jobs:getNames",function(value)
        labels = value
end)

Citizen.CreateThread(
    function()
        local ped = PlayerPedId()
        while true do
            Citizen.Wait(1000)

            if craftingQueue[1] ~= nil then
                if not Config.CraftingStopWithDistance or (Config.CraftingStopWithDistance and isNearWorkbench()) then
                    craftingQueue[1].time = craftingQueue[1].time - 1

                    ExecuteCommand("e mechanic4")
                    FreezeEntityPosition(ped,true)

                    SendNUIMessage(
                        {
                            type = "addqueue",
                            item = craftingQueue[1].item,
                            time = craftingQueue[1].time,
                            id = craftingQueue[1].id
                        }
                    )

                    if craftingQueue[1].time == 0 then
                        TriggerServerEvent("core_crafting:itemCrafted", craftingQueue[1].item, craftingQueue[1].count)
                        ExecuteCommand("e weedbrick")
                        Wait(1000)
                        table.remove(craftingQueue, 1)
                        ExecuteCommand("e c")
                        FreezeEntityPosition(ped,false)
                    end
                end
            end
        end
    end
)

function openWorkbench(val)
            SetNuiFocus(true, true)
            TriggerScreenblurFadeIn(500)

            local inv = {}
            --[[for _, v in ipairs(ESX.GetPlayerData().inventory) do
                inv[v.name] = v.count
            end]]

            local recipes = {}

            if #val.recipes > 0 then
                for _, g in ipairs(val.recipes) do
                    recipes[g] = Config.Recipes[g]
                end
            else
                recipes = Config.Recipes
            end
            SendNUIMessage(
                {
                    type = "open",
                    recipes = recipes,
                    names = labels,
                    level = xp,
                    inventory = inv,
                    job = job,
                    grade = grade,
                    hidecraft = Config.HideWhenCantCraft,
                    categories = Config.Categories
                }
            )
end

Citizen.CreateThread(function()
	while true do
		local biSleep = 500
        local ped = PlayerPedId()
        local coords = GetEntityCoords(ped)
        for _, v in ipairs(Config.Workbenches) do
            local dst = #(coords - v.coords)
            if dst < 2 then
                biSleep = 3
                DrawText3D(v.coords[1], v.coords[2], v.coords[3] - 0.1, Config.Text["workbench_hologram"])
                if IsControlJustReleased(0, Keys["E"]) then
                    TriggerServerEvent("core_jobs:getOre")
                    TriggerServerEvent("core_jobs:getNames")
                    Citizen.Wait(200)
                    local open = false
                    for _, g in ipairs(v.jobs) do
                        print(g,job)
                        if g == job then
                            open = true
                        end
                    end
                    local open = false
                    for _, g in ipairs(v.jobs) do
                        print(g,job)
                        if g == job then
                            open = true
                        end
                    end

                    if open or #v.jobs == 0 then
                        openWorkbench(v)
                    else
                        vRP.notify({"Nu ai acess!"})
                    end
                end
            end
		end
		Citizen.Wait(biSleep)
	end
end)

RegisterNetEvent("core_crafting:craftStart")
AddEventHandler(
    "core_crafting:craftStart",
    function(item, count)
        local id = math.random(000, 999)
        table.insert(craftingQueue, {time = Config.Recipes[item].Time, item = item, count = 1, id = id})

        SendNUIMessage(
            {
                type = "crafting",
                item = item
            }
        )

        SendNUIMessage(
            {
                type = "addqueue",
                item = item,
                time = Config.Recipes[item].Time,
                id = id
            }
        )
    end
)

RegisterNetEvent("core_crafting:sendMessage")
AddEventHandler(
    "core_crafting:sendMessage",
    function(type, msg)
        vRP.notify({msg})
    end
)

RegisterNUICallback(
    "close",
    function(data)
        TriggerScreenblurFadeOut(500)
        SetNuiFocus(false, false)
    end
)

RegisterNUICallback(
    "craft",
    function(data)
        local item = data["item"]
        local ped = PlayerPedId()
        TriggerServerEvent("core_crafting:craft", item, false)
        TriggerScreenblurFadeOut(500)
        SetNuiFocus(false, false)
        SendNUIMessage({
            type = "close",
        })
    end
)

function DrawText3D(x,y,z, text)

    SetTextScale(0.35, 0.35)
    SetTextFont(4)
    SetTextProportional(1)
    SetTextColour(255, 255, 255, 215)
    SetTextEntry("STRING")
    SetTextCentre(true)
    AddTextComponentString(text)
    SetDrawOrigin(x,y,z, 0)
    DrawText(0.0, 0.0)
end












